*** Object.c.~1.243.~	Mon Jan 15 18:00:36 2007
--- Object.c	Tue Jan 16 12:25:56 2007
***************
*** 2393,2400 ****
  	BPy_Action *sourceact;
  	char *chanName;
  	int actframe;
! 
! 
  	/* for doing the time trick, similar to editaction bake_action_with_client() */
  	int oldframe;
  	int curframe;
--- 2393,2400 ----
  	BPy_Action *sourceact;
  	char *chanName;
  	int actframe;
! 	char error[256]; /* for py error msgs. using a largish buffer to be on the safe side if someone is using huge channel names (dunno if there is an maximum in blender for those, though.  */
! 	
  	/* for doing the time trick, similar to editaction bake_action_with_client() */
  	int oldframe;
  	int curframe;
***************
*** 2404,2417 ****
  		return EXPP_ReturnPyObjError( PyExc_TypeError,
  				"expects an action to copy poses from, a string for chan/bone name, an int argument for frame to extract from the action and finally another int for the frame where to put the new key in the active object.action" );
  
! 	extract_pose_from_action(ob->pose, sourceact->action, (float)actframe);
  
  	oldframe = G.scene->r.cfra;
  	G.scene->r.cfra = curframe;
  
- 	/* XXX: must check chanName actually exists, otherwise segfaults! */
- 	//achan = get_action_channel(sourceact->action, chanName);
- 
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_X);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Y);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Z);
--- 2404,2425 ----
  		return EXPP_ReturnPyObjError( PyExc_TypeError,
  				"expects an action to copy poses from, a string for chan/bone name, an int argument for frame to extract from the action and finally another int for the frame where to put the new key in the active object.action" );
  
! 	if (!get_action_channel(sourceact->action, chanName)) {
! 	  printf("\ncaught invalid chanName\n");
! 	  PyOS_snprintf( error, sizeof(error),
! 			 "No channel called \"%s\" in the given action.", chanName);
! 	  return EXPP_ReturnPyObjError( PyExc_ValueError,
! 					error ); 
! 	}
! 	else {
! 	  printf("\nchanname found.\n");
! 	}
! 
! 	extract_pose_from_action(ob->pose, sourceact->action, (float) actframe); //dunno if the float is really necessary
  
  	oldframe = G.scene->r.cfra;
  	G.scene->r.cfra = curframe;
  
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_X);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Y);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Z);
***************
*** 2448,2453 ****
--- 2456,2462 ----
  	/* for doing the time trick, similar to editaction bake_action_with_client() */
  	int oldframe;
  	int curframe;
+ 	char error[256]; /* for py error msgs */
  
  	if( !PyArg_ParseTuple( args, "si", &chanName, &curframe ) )
  		return EXPP_ReturnPyObjError( PyExc_TypeError,
***************
*** 2456,2462 ****
  	oldframe = G.scene->r.cfra;
  	G.scene->r.cfra = curframe;
  
! 	/* XXX: must check chanName actually exists, otherwise segfaults! */
  
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_X);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Y);
--- 2465,2485 ----
  	oldframe = G.scene->r.cfra;
  	G.scene->r.cfra = curframe;
  
! 	if( self->object->action ) {
! 	  printf("\nhas action\n");
! 	  if (!get_action_channel(self->object->action, chanName)) {
! 	    PyOS_snprintf( error, sizeof(error),
! 			   "No channel called \"%s\" in the given action.", chanName);
! 	    return EXPP_ReturnPyObjError( PyExc_ValueError,
! 					  error ); 
! 	  }
! 	  printf(".. with channame\n");
! 	}
! 	else { //the ob has no current action where to add the key to
! 	  printf("\nno action\n");
! 	  return EXPP_ReturnPyObjError( PyExc_ValueError,
! 					"This object has no active action to insert keys to.");
! 	}
  
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_X);
  	insertkey(&ob->id, ID_PO, chanName, NULL, AC_LOC_Y);
